#include <stdio.h>
#include <stdlib.h>

#include <ecm.h>

int main (int argc, char **argv)
{
	curve *c;
	point *p1, *p2, *res;
	
	if (argc<8)
	{
		fprintf(stderr, "calc a b p p1x p1y p2x p2y\n");
		fprintf(stderr, "\tBerechnet (p1x, p1y) + (p2x, p2y) ueber der elliptischen\n");
		fprintf(stderr, "\tKurve y=x+ax+b ueber GF(p).\n");
		return 1;
	}

	set_verbose3(true);

	c=curveify(ATOI(argv[1]), ATOI(argv[2]), ATOI(argv[3]));
	p1=pointify(ATOI(argv[4]), ATOI(argv[5]));
	p2=pointify(ATOI(argv[6]), ATOI(argv[7]));
	res=add(c, p1, p2);

	printf("%s + %s = %s\n", dump_point(p1), dump_point(p2), dump_point(res));

	free(c);
	free(p1);
	free(p2);
	free(res);
	return 0;
}
