#ifndef __ELGEC_H__
#define __ELGEC_H__

#ifdef __cplusplus
extern "C" {
#endif

#include <ecm.h>

/** Struktur fuer einen Krypto-Vektor */
typedef struct
{
	/** Kryptogram */
	point *Cx;
	/** Random-Number */
	point *rx;
} crypt_vector;

/** Setze 'verbose' Flag 
@param val Neuer Wert
*/
void set_verbose2 (bool val);

/** Verschluessele eine Nachricht 
@param crv Die elliptische Kurve
@param msg Die zu verschluesselnde Nachricht
@param Ya Public Key
@return Zu sendender Krypto-Vektor
*/
crypt_vector *encrypt (curve *crv, point *msg, point *Ya);

/** Verschluessele eine Nachricht
@param crv Die elliptische Kurve
@param msg Die zu verschluesselnde Nachricht
@param Ya Public Key
@param R Die Zufallszahl
@return Zu sendender Krypto-Vektor
*/
crypt_vector *encr (curve *crv, point *msg, point *Ya, INT R);

/** Entschluessele einen Krypto-Vektor
@param crv Die elliptische Kurve
@param c Der Krypto-Vektor
@param Xa Secret Key
@return Die entschluesselte Nachricht
*/
point *decrypt (curve *crv, crypt_vector *c, INT Xa);

/** Berechne aus dem Secret Key den Public Key
@param crv Die Kurve
@param Xa Secret Key
@return Public Key
*/
point *public_key (curve *crv, INT Xa);

/** Erzeuge zufaelligen Secret Key
@param crv Die Kurve
@return Secret Key
*/
INT secret_key (curve *crv);

#ifdef __cplusplus
}
#endif
#endif
